<?php

namespace Slack\Blockkit\Blocks\Elements;

use Slack\Blockkit\Element;
use Slack\Exceptions\SlackSyntaxException;

final class Text extends Element
{
	public const TYPES = ['mrkdwn','plain_text'];

	public function __construct(string $text,string $type)
	{
		parent::__construct();

		if (! in_array($type,self::TYPES))
			throw new SlackSyntaxException(sprintf('Type [%s] not valid',$type));

		$this->text = $text;
		$this->type = $type;
	 }

	public static function item(string $text,string $type='mrkdwn'): self
	{
		return new self($text,$type);
	}

	/* OPTIONAL ITEMS */

	public function emoji(bool $bool): self
	{
		if ($this->type != 'plain_text')
			throw new SlackSyntaxException(sprintf('Cannnot use emoji when type is [%s]',$this->type));

		$this->emoji = $bool;

		return $this;
	}

	public function verbatim(bool $bool): self
	{
		$this->verbatim = $bool;

		return $this;
	}
}